#pragma once
#include <string>
#include <initializer_list>
#include <map>
#include <any>
#include <vector>
#include <exception>
#include <cmath>

struct parking {
	char owner_name[100];
	int car_number;
	double tariff;
	int day_start;
	int day_end;
	int time_start;
	int time_end;

	parking() = default;
	parking(const char*, int, double, int, int, int, int);
	friend std::istream& operator >> (std::istream& is, parking& t_parking);
	friend std::ostream& operator << (std::ostream& os, const parking& t_parking);
};


class Record {
private:
	std::string name_record;
	std::map<int, parking> record_map;
	void get_data();
public:
	Record() = default;
	~Record() = default;
	Record(const std::string&);
	void create_record();
	void add_to_record(const parking&);
	void add_to_record_list(const std::initializer_list<parking>&);
	void delete_from_record(int);
	void replace_in_record(int, const parking&);
	void transform_into_text();

	void search_by_name(const std::string&);
	void search_by_car_number(int);
	void search_by_date(int);
	void search_by_time(int);
};
